backend/models/Reservation.php
<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "reservation".
 *
 * @property string $pkReservationID
 * @property string $fkAdID
 * @property string $fkCategoryID
 * @property integer $confirmation
 * @property string $userName
 * @property string $userEmail
 * @property string $phoneNumber
 * @property string $bookingDate
 * @property string $bookingTime
 * @property integer $person
 * @property string $timestamp
 *
 * @property Category $fkCategory
 * @property Ad $fkAd
 */
class Reservation extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public $title;
    public static function tableName()
    {
        return 'reservation';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['fkAdID', 'fkCategoryID', 'confirmation', 'person'], 'integer'],
            [['userName', 'bookingDate'], 'string', 'max' => 100],
            [['title'], 'safe'],
            [['userEmail', 'phoneNumber', 'bookingTime', 'timestamp'], 'string', 'max' => 20],
            [['fkCategoryID'], 'exist', 'skipOnError' => true, 'targetClass' => Category::className(), 'targetAttribute' => ['fkCategoryID' => 'pkCategoryID']],
            [['fkAdID'], 'exist', 'skipOnError' => true, 'targetClass' => Ad::className(), 'targetAttribute' => ['fkAdID' => 'pkAdID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'pkReservationID' => 'Pk Reservation ID',
            'fkAdID' => 'Fk Ad ID',
            'fkCategoryID' => 'Fk Category ID',
            'confirmation' => 'Confirmation',
            'userName' => 'User Name',
            'userEmail' => 'User Email',
            'phoneNumber' => 'Phone Number',
            'bookingDate' => 'Booking Date',
            'bookingTime' => 'Booking Time',
            'person' => 'Person',
            'timestamp' => 'Timestamp',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFkCategory()
    {
        return $this->hasOne(Category::className(), ['pkCategoryID' => 'fkCategoryID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFkAd()
    {
        return $this->hasOne(Ad::className(), ['pkAdID' => 'fkAdID']);
    }
}

backend/controllers/ReservationController.php
<?php

namespace backend\controllers;

use Yii;
use backend\models\Reservation;
use backend\models\SearchReservation;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;

/**
 * ReservationController implements the CRUD actions for Reservation model.
 */
class ReservationController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['login'],
                        'allow' => true,
                    ],
                    [
                       'actions' => ['view', 'index','create','update','delete'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all Reservation models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new SearchReservation();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Reservation model.
     * @param string $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Reservation model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    // public function actionCreate()
    // {
    //     $model = new Reservation();

    //     if ($model->load(Yii::$app->request->post()) && $model->save()) {
    //         return $this->redirect(['view', 'id' => $model->pkReservationID]);
    //     } else {
    //         return $this->render('create', [
    //             'model' => $model,
    //         ]);
    //     }
    // }

    /**
     * Updates an existing Reservation model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $id
     * @return mixed
     */
    // public function actionUpdate($id)
    // {
    //     $model = $this->findModel($id);

    //     if ($model->load(Yii::$app->request->post()) && $model->save()) {
    //         return $this->redirect(['view', 'id' => $model->pkReservationID]);
    //     } else {
    //         return $this->render('update', [
    //             'model' => $model,
    //         ]);
    //     }
    // }

    /**
     * Deletes an existing Reservation model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Reservation model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $id
     * @return Reservation the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Reservation::find()->joinWith(['fkCategory','fkAd'])->where(['pkReservationID' => $id])->one()) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

backend/views/reservation/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model backend\models\Reservation */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="reservation-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'fkAdID')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'fkCategoryID')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'confirmation')->textInput() ?>

    <?= $form->field($model, 'userName')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'userEmail')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'phoneNumber')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'bookingDate')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'bookingTime')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'person')->textInput() ?>

    <?= $form->field($model, 'timestamp')->textInput(['maxlength' => true]) ?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? 'Create' : 'Update', ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

backend/views/reservation/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\Ad;

/* @var $this yii\web\View */
/* @var $model backend\models\AdSearch */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="col-md-12 searchCat">
<div class="box">
<div class="box-header">
<h3>Search</h3>
</div>

<div class="box-body">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <div class="row">
    <div class="col-lg-3 col-sm-4">
        <?php
        $items = ArrayHelper::map(Ad::find()->where(['dinning' => '1'])->joinWith(['categoryAdOrders'])->orderBy(['categoryAdOrder.position' => SORT_ASC])->all(), 'pkAdID', 'title');
              
        echo $form->field($model, 'fkAdID')->dropdownList($items,
        ['prompt'=>'Select Ad'])->label(false);
        ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'subTitle')->textInput()->input('text', ['placeholder' => "Ad Sub Title"])->label(false); ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'fromDate')->textInput()->input('text', ['placeholder' => "Booking From",'id' => 'datepickerFrom'])->label(false); ?>

         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'toDate')->textInput()->input('text', ['placeholder' => "Booking To",'id' => 'datepickerTo'])->label(false); ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'userName')->textInput()->input('text', ['placeholder' => "Users Name"])->label(false); ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'phoneNumber')->textInput()->input('text', ['placeholder' => "Phone Number"])->label(false); ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'person')->textInput()->input('text', ['placeholder' => "No. of People"])->label(false); ?>
         </div>
    <div class="col-lg-3 col-sm-4">
        <?= Html::submitButton('Search', ['class' => 'btn btn-info']) ?>
    </div>

    <?php ActiveForm::end(); ?>
    </div>
</div>
</div>
</div>

    <?php // echo $form->field($model, 'bookingDate') ?>

backend/views/reservation/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model backend\models\Reservation */

$this->title = 'Create Reservation';
$this->params['breadcrumbs'][] = ['label' => 'Reservations', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="reservation-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/reservation/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\SearchReservation */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'All Reservations';
//$this->params['breadcrumbs'][] = $this->title;
?>
<section class="content-header">
        <h1><?= Html::encode($this->title) ?></h1>
    </section>
    <section class="content">

<?php echo $this->render('_search', ['model' => $searchModel]); ?>
    <div class="col-md-12">
    <div class="box">
    <div class="box-body">

      <?= GridView::widget([
        'dataProvider' => $dataProvider,
        //'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
                'attribute' => 'Ad Title',
                'value' => function($dataProvider){ 
                    //echo '<pre>'; print_r($dataProvider); echo '</pre>'; die();
                      $url = Url::to(['ad/view']);
                      $finalUrl = $url.'?id='.$dataProvider->fkAd->pkAdID;
                      
                      $adTitle = $dataProvider->fkAd->title;
                      $adSubTitle = $dataProvider->fkAd->subTitle;
                      return '<u><a href="'.$finalUrl.'">'.$adTitle.'('.$adSubTitle.')'.'</a></u>';
                },
                'format' => 'html'
            ],
            [
                'attribute' => 'Category Name',
                'value' => function($dataProvider){
                    //echo '<pre>'; print_r($dataProvider); echo '</pre>'; die();
                      $catName = $dataProvider->fkCategory->categoryName;
                      return $catName;
                },
                'format' => 'html'
            ],
            [
                'attribute' => 'Users Name',
                'value' => function($dataProvider){
                      $url = Url::to(['reservation/view']);
                      $finalUrl = $url.'?id='.$dataProvider->pkReservationID;
                      return '<u><a href="'.$finalUrl.'">'.$dataProvider->userName.'</a></u>';
                },
                'format' => 'html'
            ],
            [
                'attribute' => 'Phone No.',
                'value' => 'phoneNumber',
                'format' => 'html'
            ],
            [
                'attribute' => 'No. of people',
                'value' => function($dataProvider){ 
                      $people = $dataProvider->person;
                      return '<span class="positionInfo">'.$people.'</span>';
                },
                'format' => 'html'
            ],
            [
                'attribute' => 'Booking Date',
                'value' => function($dataProvider){
                    //echo '<pre>'; print_r($dataProvider); echo '</pre>'; die();
                      $date = trim($dataProvider->bookingDate);
                      $currDate = date('Y-m-d');
                      if(($date == $currDate) || ($date < $currDate))
                      {
                        $color = '#dd4b39';
                      }else{
                        $color = '#00a65a';
                      }
                      $newDate = date("d F Y", strtotime($date));
                      return '<span style="color:'.$color.'">'.$newDate.'</span>';
                },
                'format' => 'html'
            ],
            [
                'attribute' => 'Time',
                'value' => function($dataProvider){ 
                      return '<span class="adInfo">'.$dataProvider->bookingTime.'</span>';
                },
                'format' => 'html'
            ],
            // 'timestamp',

            ['class' => 'yii\grid\ActionColumn', 'template' => '{view}{delete}'],
        ],
    ]); ?>
      
    </div>
    </div>
    </div>


</section>

backend/views/reservation/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model backend\models\Reservation */

$this->title = 'Update Reservation: ' . $model->pkReservationID;
$this->params['breadcrumbs'][] = ['label' => 'Reservations', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->pkReservationID, 'url' => ['view', 'id' => $model->pkReservationID]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="reservation-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/reservation/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $model backend\models\Reservation */

$this->title = 'View Reservation';
// $this->params['breadcrumbs'][] = ['label' => 'Reservations', 'url' => ['index']];
// $this->params['breadcrumbs'][] = $this->title;
?>
<section class="content-header">
        <h1><?= Html::encode($this->title) ?></h1>
    </section>

    <section class="content">
    <div class="col-md-6">
        <?= Html::a('Delete', ['delete', 'id' => $model->pkReservationID], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this category?',
                'method' => 'post',
            ],
        ]) ?>
        </div>
<?php
    //echo '<pre>'; print_r($model); echo '</pre>'; die;

$pkReservationID = (isset($model->pkReservationID)) ? $model->pkReservationID : '';
$categoryName = (isset($model->fkCategory->categoryName)) ? $model->fkCategory->categoryName : '';

$active = (isset($model->fkAd->active)) ? $model->fkAd->active : '';
$title = (isset($model->fkAd->title)) ? $model->fkAd->title : '';
$subTitle = (isset($model->fkAd->subTitle)) ? $model->fkAd->subTitle : '';
$address = (isset($model->fkAd->address)) ? $model->fkAd->address : '';
$streetName = (isset($model->fkAd->streetName)) ? $model->fkAd->streetName : '';
$cityName = (isset($model->fkAd->cityName)) ? $model->fkAd->cityName : '';
$countryName = (isset($model->fkAd->countryName)) ? $model->fkAd->countryName : '';
$contactNumber = (isset($model->fkAd->contactNumber)) ? $model->fkAd->contactNumber : '';

$finalAddress = $address.' '.$streetName.' '.$cityName.' '.$countryName;

$userName = (isset($model->userName)) ? $model->userName : '';
$userEmail = (isset($model->userEmail)) ? $model->userEmail : '';
$phoneNumber = (isset($model->phoneNumber)) ? $model->phoneNumber : '';
$bookingDate = (isset($model->bookingDate)) ? $model->bookingDate : '';
$bookingTime = (isset($model->bookingTime)) ? $model->bookingTime : '';
$person = (isset($model->person)) ? $model->person : '';
$timestamp = (isset($model->timestamp)) ? $model->timestamp : '';
?>
<div class="row">
    <div class="col-md-8 viewCat">
        <div class="box">
            <div class="box-header">
              <h3 class="box-title">Restaurant Information</h3>
            </div>
            <!-- /.box-header -->
            <div class="box-body no-padding">
              <table class="table table-striped catView">
                <tbody>
                <tr>
                  <th>Restaurant title</th>
                  <td><span class="position-info"><?php echo $title;?></span></td>
                </tr>
                <tr>
                  <th>Sub-title</th>
                  <td><span class="adInfo"><?php echo $subTitle;?></span></td>
                </tr>
                <tr>
                  <th>Category Name</th>
                  <td><?php echo $categoryName;?></td>
                </tr>
                <tr>
                  <th>Active</th>
                  <td><?php if($active == '1'){?>
                    <i class="fa fa-check" aria-hidden="true"></i>
                   <?php }else{?>
                   <i class="fa fa-times" aria-hidden="true"></i>
                   <?php }?></td>
                </tr>
                <tr>
                  <th>Address</th>
                  <td><?php echo $finalAddress;?></td>
                </tr>
                <tr>
                  <th>Contact Number</th>
                  <td><?php echo $contactNumber;?></td>
                </tr>
                <tr>
                  <th>Date & Time of booking</th>
                  <td><?php 
                  echo gmdate("j F Y, g:i a", $timestamp);?></td>
                </tr>
              </tbody></table>
            </div>
          </div>

          <div class="box">
            <div class="box-header">
              <h3 class="box-title">User Information</h3>
            </div>
            <!-- /.box-header -->
            <div class="box-body no-padding">
              <table class="table table-striped catView">
                <tbody>
                <tr>
                  <th>User Name</th>
                  <td><span class="adInfo"><?php echo $userName;?></span></td>
                </tr>
                <tr>
                  <th>Email</th>
                  <td><?php echo $userEmail;?></td>
                </tr>
                <tr>
                  <th>Contact Number</th>
                  <td><?php echo $phoneNumber;?></td>
                </tr>
                <tr>
                  <th>No. of people</th>
                  <td><?php echo $person;?></td>
                </tr>
                  
                <tr>
                  <th>Booking date & time</th>
                  <td><?php 
                      $date = trim($bookingDate);
                      $currDate = date('Y-m-d');
                      if(($date == $currDate) || ($date < $currDate))
                      {
                        $color = '#dd4b39';
                      }else{
                        $color = '#00a65a';
                      }
                      $newDate = date("d F Y", strtotime($date));
                      echo '<b><span style="color:'.$color.'">'.$newDate.', '.$bookingTime.'</span></b>';
                  ?></td>
                </tr>
              </tbody></table>
            </div>
            <!-- /.box-body -->
          </div>
          </div>
          </div>

 </section>